
int charDev =  0x40000000;

// reads a char from default device
int readChar() {
  return _readChar(charDev);
}

// reads a char with echoing from given device
int _readChar(int* dev) {
  // first wait until the user types a character
  _wait(dev);
  // then consume the character
  char ch = dev[1];
  // now echo the character
  _printChar(dev, ch);
  return ch;
}

// prints a char to the default device
void _printChar(int* dev, int ch) {
  dev[3] = ch;
}

// wait for a given device to become ready
void _wait(int* p) {
  while ((p[0] & 1) == 0) {}
}

void main() {
  char ch = readChar();
  // If you wish, you can just test the functionality of _wait here,
  // To do so, just uncomment the next line:
  // _wait(charDev);
}
